﻿using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Builders;

namespace Demo.ConsoleApp.Data.Configuration
{
	class CustomerConfiguration : IEntityTypeConfiguration<Customers>
	{
		public void Configure(EntityTypeBuilder<Customers> builder)
		{
			builder.HasKey(e => e.CustomerId);

			builder.HasIndex(e => e.CompanyName)
								.HasName("CompanyName");

			builder.Property(e => e.CustomerId)
								.HasColumnName("CustomerID")
								.HasColumnType("nchar(5)")
								.ValueGeneratedNever();

			builder.Property(e => e.CompanyName)
								.IsRequired()
								.HasMaxLength(40);

			builder.Property(e => e.ContactName).HasMaxLength(30);

			builder.Property(e => e.ContactTitle).HasMaxLength(30);

			builder.OwnsOne(e => e.Address).Property(e => e.Address).HasColumnName("address");
			builder.OwnsOne(e => e.Address).Property(e => e.City).HasColumnName("City");
			builder.OwnsOne(e => e.Address).Property(e => e.Country).HasColumnName("Country");
			builder.OwnsOne(e => e.Address).Property(e => e.PostalCode).HasColumnName("PostalCode");
			builder.OwnsOne(e => e.Address).Property(e => e.Region).HasColumnName("Region");

			builder.Property(e => e.Fax).HasMaxLength(24);

			builder.Property(e => e.Phone).HasMaxLength(24);
		}
	}
}
